
--[[ list of all functions that are relevent
BuyMerchantItem(index[, qty]) -- no return
honorPoints, arenaPoints, itemCount = GetMerchantItemCostInfo(index);
itemTexture, itemValue, itemLink = GetMerchantItemCostItem(index, itemIndex) -- itemIndex <= itemCount from GetMerchantItemCostInfo
name, texture, price, quantity, numAvailable, isUsable, extendedCost = GetMerchantItemInfo(index)
link = GetMerchantItemLink(index);
maxStack = GetMerchantItemMaxStack(index)
numItems = GetMerchantNumItems();
PickupMerchantItem(index) -- no return
ShowMerchantSellCursor(index) -- no return
GameTooltip:SetMerchantItem(merchantIndex)
]]

local _, GVF = ...
_G["GVF"] = GVF

GVF.indexLookup = {}
GVF.types ={}
GVF.types_filtered ={}
GVF.subtypes ={}
GVF.subtypes_filtered ={}
GVF.equipLoc ={}
GVF.equipLoc_filtered ={}
GVF.maxIndex = 0

GVF.frame = CreateFrame('frame')
GVF.frame:SetScript("OnEvent", function()
	wipe(GVF.types_filtered)
	wipe(GVF.equipLoc_filtered)
	for _, st in pairs(GVF.subtypes_filtered) do
		wipe(st)
	end
	CloseDropDownMenus()
end)
GVF.frame:RegisterEvent("MERCHANT_CLOSED")

local function NumEntries(t)
	if t then
		local count = 0
		for k in pairs(t) do
			count = count + 1
		end
		return count
	else
		return 0
	end
end

-- Let the mad hooking begin
-- we replace all the merchant functions and reroute them through our own
-- this enables us to modify any an all merchant addon out there :)
local GetMerchantNumItems_old = GetMerchantNumItems
local GetMerchantItemLink_old = GetMerchantItemLink

local function GenerateIndexLookup()
	wipe(GVF.indexLookup)
	GVF.indexLookup[0] = 0
	wipe(GVF.types)
	wipe(GVF.equipLoc)
	for _, st in pairs(GVF.subtypes) do
		wipe(st)
	end
	GVF.maxIndex = 0
	for i=1, GetMerchantNumItems_old() do
		local link = GetMerchantItemLink_old(i)
		if link then
			local _, _, _, _, _, itemType, itemSubType, _, itemEquipLoc = GetItemInfo(link)
			GVF.types[itemType] = true
			GVF.subtypes[itemType] = GVF.subtypes[itemType] or {}
			GVF.subtypes[itemType][itemSubType] = true
			GVF.equipLoc[itemEquipLoc] = true
			if not(GVF.equipLoc_filtered[itemEquipLoc] or (GVF.types_filtered[itemType] and NumEntries(GVF.subtypes[itemType]) <= 1) or (GVF.subtypes_filtered[itemType] and GVF.subtypes_filtered[itemType][itemSubType])) then
				GVF.maxIndex = GVF.maxIndex + 1
				GVF.indexLookup[GVF.maxIndex] = i
			end
		else
			GVF.maxIndex = GVF.maxIndex + 1
			GVF.indexLookup[GVF.maxIndex] = i
		end
	end
end

function GetMerchantNumItems()
	GenerateIndexLookup()
	return GVF.maxIndex
end

function GetMerchantItemLink(index)
	return GetMerchantItemLink_old(GVF.indexLookup[index])
end

local BuyMerchantItem_old = BuyMerchantItem
function BuyMerchantItem(index, qty)
	return BuyMerchantItem_old(GVF.indexLookup[index], qty)
end

local GetMerchantItemCostInfo_old = GetMerchantItemCostInfo
function GetMerchantItemCostInfo(index, qty)
	return GetMerchantItemCostInfo_old(GVF.indexLookup[index], qty)
end

local GetMerchantItemCostItem_old = GetMerchantItemCostItem
function GetMerchantItemCostItem(index, itemIndex)
	return GetMerchantItemCostItem_old(GVF.indexLookup[index], itemIndex)
end

local GetMerchantItemInfo_old = GetMerchantItemInfo
function GetMerchantItemInfo(index)
	return GetMerchantItemInfo_old(GVF.indexLookup[index])
end

local GetMerchantItemMaxStack_old = GetMerchantItemMaxStack
function GetMerchantItemMaxStack(index)
	return GetMerchantItemMaxStack_old(GVF.indexLookup[index])
end

local PickupMerchantItem_old = PickupMerchantItem
function PickupMerchantItem(index)
	return PickupMerchantItem_old(GVF.indexLookup[index])
end

local ShowMerchantSellCursor_old = ShowMerchantSellCursor
function ShowMerchantSellCursor(index)
	return ShowMerchantSellCursor_old(GVF.indexLookup[index])
end

local GameTooltip_SetMerchantItem_old = GameTooltip.SetMerchantItem
function GameTooltip:SetMerchantItem(index)
	return GameTooltip_SetMerchantItem_old(self, GVF.indexLookup[index])
end

-- and we are done hooking

GVF.FilterMenu = CreateFrame("Frame", "GVF_FilterMenu", GVF.frame)
GVF.FilterMenu.onHide = function(...)
	MenuParent = nil
	MenuItem = nil
	MenuEquipSlot = nil
end
GVF.FilterMenu.HideMenu = function()
    if UIDROPDOWNMENU_OPEN_MENU == GVF.FilterMenu then
        CloseDropDownMenus()
    end
end

--MERCHANT_UPDATE
local function UpdateMerchant()
	local frame = EnumerateFrames()
	while frame do
		if frame:IsEventRegistered("MERCHANT_UPDATE") then
			local func = frame:GetScript("OnEvent")
			func(frame, "MERCHANT_UPDATE")
		end
		frame = EnumerateFrames(frame)
	end
	GenerateIndexLookup()
end

local FilterButton = CreateFrame('Button',nil,MerchantFrame)
	FilterButton:SetWidth(30)
	FilterButton:SetHeight(30)
	FilterButton:SetPoint("TOPRIGHT", MerchantFrame, "TOPRIGHT",-55,-9)
	FilterButton:SetNormalTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Up]])
	FilterButton:SetPushedTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Down]])
	FilterButton:SetDisabledTexture([[Interface\ChatFrame\UI-ChatIcon-ScrollDown-Disabled]])
	FilterButton:SetHighlightTexture([[Interface\Buttons\UI-Common-MouseHilight]])
	FilterButton:SetScript('OnClick', function(self)
		ToggleDropDownMenu(1, nil, GVF.FilterMenu, self, 0, 0)
	end)

local info, itemtypesorted, itemtypesortedL = {}, {}, {}
GVF.FilterMenu.initialize = function(self, level)
	if not level then return end
	wipe(info)
	wipe(itemtypesorted)
	info.keepShownOnClick = 1
    if level == 1 then
		for t in pairs(GVF.types) do
			itemtypesorted[#itemtypesorted+1] = t
		end
		table.sort(itemtypesorted)

		for i = 1, #itemtypesorted do
			info.text = itemtypesorted[i]
			info.arg1 = itemtypesorted[i]
			info.value = itemtypesorted[i]
			info.hasArrow = NumEntries(GVF.subtypes[itemtypesorted[i]]) > 1
			info.checked = not GVF.types_filtered[itemtypesorted[i]]
			info.func = function(button, arg1)
				local b = not GVF.types_filtered[arg1]
				GVF.types_filtered[arg1] = b
				if GVF.subtypes[arg1] then
					for st in pairs(GVF.subtypes[arg1]) do
						GVF.subtypes_filtered[arg1] = GVF.subtypes_filtered[arg1] or {}
						GVF.subtypes_filtered[arg1][st] = b
					end
				end
				ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
				ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
				UpdateMerchant()
			end
			UIDropDownMenu_AddButton(info, level)
		end
		
		info.text = ITEMSLOTTEXT
		info.value = ITEMSLOTTEXT
		info.hasArrow = true
        info.notCheckable = 1
		info.checked = nil
		info.func = nil
		UIDropDownMenu_AddButton(info, level)
		
		info.text = GREEN_FONT_COLOR_CODE..'Check All'
		info.hasArrow = nil
        info.value = nil
		info.func = function(button)
			wipe(GVF.types_filtered)
			for _, st in pairs(GVF.subtypes_filtered) do
				wipe(st)
			end
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
			UpdateMerchant()
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = RED_FONT_COLOR_CODE..'Uncheck All'
		info.func = function(button)
			for t in pairs(GVF.types) do
				GVF.types_filtered[t] = true
				for st in pairs(GVF.subtypes[t]) do
					GVF.subtypes_filtered[t] = GVF.subtypes_filtered[t] or {}
					GVF.subtypes_filtered[t][st] = true
				end
			end
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
			ToggleDropDownMenu(1, nil, GVF.FilterMenu, FilterButton, 0, 0)
			UpdateMerchant()
		end
		UIDropDownMenu_AddButton(info, level)

		info.text = CLOSE
		info.func = self.HideMenu
		UIDropDownMenu_AddButton(info, level)

	elseif level == 2 then
		if ITEMSLOTTEXT == UIDROPDOWNMENU_MENU_VALUE then
			for l in pairs(GVF.equipLoc) do
				local L = _G[l]
				if L then
					itemtypesorted[#itemtypesorted+1] = L
					itemtypesortedL[L] = l
				end
			end
			table.sort(itemtypesorted)

			for i = 1, #itemtypesorted do
				info.text = itemtypesorted[i]
				info.arg1 = itemtypesortedL[itemtypesorted[i]]
				info.checked = not GVF.equipLoc_filtered[itemtypesortedL[itemtypesorted[i]]]
				info.func = function(button, arg1)
					GVF.equipLoc_filtered[arg1] = not GVF.equipLoc_filtered[arg1]
					UpdateMerchant()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		else
			for st in pairs(GVF.subtypes[UIDROPDOWNMENU_MENU_VALUE]) do
				itemtypesorted[#itemtypesorted+1] = st
			end
			table.sort(itemtypesorted)

			for i = 1, #itemtypesorted do
				info.text = itemtypesorted[i]
				info.arg1 = UIDROPDOWNMENU_MENU_VALUE
				info.arg2 = itemtypesorted[i]
				info.checked = not (GVF.subtypes_filtered[UIDROPDOWNMENU_MENU_VALUE] and GVF.subtypes_filtered[UIDROPDOWNMENU_MENU_VALUE][itemtypesorted[i]])
				info.func = function(button, arg1, arg2)
					GVF.subtypes_filtered[arg1] = GVF.subtypes_filtered[arg1] or {}
					GVF.subtypes_filtered[arg1][arg2] = not GVF.subtypes_filtered[arg1][arg2]
					UpdateMerchant()
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end
	end
end
